## quickjs 2021.03.27

=== debian/changelog ===
quickjs (2021.03.27-1) unstable; urgency=medium

  * Initial version (Closes: #1030776)

 -- Sebastian Humenda <shumenda@gmx.de>  Thu, 09 Feb 2023 23:58:37 +0100
