=== debian/control ===
Source: quickjs
Section: devel
Priority: optional
Maintainer: Debian Accessibility Team <pkg-a11y-devel@alioth-lists.debian.net>
Uploaders: Sebastian Humenda <shumenda@gmx.de>
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/a11y-team/quickjs.git
Vcs-Browser: https://salsa.debian.org/a11y-team/quickjs
Homepage: https://bellard.org/quickjs/

Package: quickjs
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small and embeddable Javascript engine
 QuickJS is a small and embeddable Javascript engine. It supports the
 ES2020 specification, including modules, asynchronous generators, proxies and
 BigInt.
 .
 It supports mathematical extensions such as big decimal float numbers
 (BigDecimal), big binary floating point numbers (BigFloat), and operator
 overloading.

Package: libquickjs
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small and embeddable Javascript engine library
 QuickJS is a small and embeddable Javascript engine. It supports the
 ES2020 specification, including modules, asynchronous generators, proxies and
 BigInt.
 .
 It supports mathematical extensions such as big decimal float numbers
 (BigDecimal), big binary floating point numbers (BigFloat), and operator
 overloading.
 .
 This is the library package.
