## quickjs 2024.01.13

=== debian/changelog ===
quickjs (2024.01.13-5) unstable; urgency=medium

  * Fix CVE-2024-33263 with upstream patch (Closes: #1070373)
   See <https://github.com/bellard/quickjs/issues/277> for details.

 -- Sebastian Humenda <shumenda@gmx.de>  Mon, 15 Jul 2024 16:42:17 +0200

quickjs (2024.01.13-4) unstable; urgency=medium

  * patches/fix_armel_build: Pass -latomic at the end for really fixing link.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 23 Mar 2024 14:19:07 +0100

quickjs (2024.01.13-3) unstable; urgency=medium

  * control: Fix multiarch declaration of libquickjs.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 22 Mar 2024 17:53:15 +0100

quickjs (2024.01.13-2) unstable; urgency=medium

  * fix multiarch build 

 -- Sebastian Humenda <shumenda@gmx.de>  Thu, 21 Mar 2024 14:16:27 +0100

quickjs (2024.01.13-1) unstable; urgency=medium

  * new upstream release (Closes: #1031074)

 -- Sebastian Humenda <shumenda@gmx.de>  Tue, 19 Mar 2024 19:58:17 +0100
