## quickjs 2025.04.26

=== debian/changelog ===
quickjs (2025.04.26-1) unstable; urgency=medium

  * new upstream version
  * Fix CVE-2025-46687 and CVE-2025-46688 with upstream import, see upstream
    GitHub issue #399 (Closes: #1104255)

 -- Sebastian Humenda <shumenda@gmx.de>  Sat, 03 May 2025 17:18:27 +0200
