=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 Package: libquickjs
 Architecture: any
-Multi-Arch: foreign
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: small and embeddable Javascript engine library
  QuickJS is a small and embeddable Javascript engine. It supports the
