=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,14 @@
 %:
 	dh $@
 
-override_dh_auto_test:
-	@echo ToDo, skip tests
 
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -f host-qjsc
 
+override_dh_auto_install:
+	export PREFIX=/usr; \
+		dh_auto_install
+
+override_dh_auto_test:
+	@echo ToDo, skip tests
