=== debian/watch ===
version=4
opts=uversionmangle=s/-/./g \
https://bellard.org/quickjs/ https://bellard.org/quickjs/quickjs-@ANY_VERSION@@ARCHIVE_EXT@
