## quickjs 2025.09.13

=== debian/changelog ===
quickjs (2025.09.13-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 09 Dec 2025 10:33:16 -0800

quickjs (2025.09.13-1~ppa~plucky) plucky; urgency=medium

  * Initial release.

 -- tomx3 <tomx3@tomtomtom.at>  Sat, 01 Nov 2025 09:49:42 +0100
