=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: quickjs
 Section: devel
 Priority: optional
-Maintainer: Debian Accessibility Team <pkg-a11y-devel@alioth-lists.debian.net>
-Uploaders: Sebastian Humenda <shumenda@gmx.de>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: tomx3 <tomx3@tomtomtom.at>
 Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
