=== debian/rules ===
--- 
+++ 
@@ -27,3 +27,8 @@
 
 override_dh_auto_test:
 	@echo ToDo, skip tests
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym
